/*sampler.h */
/* sampler.h,v 1.1.1.1 2005/11/03 19:58:58 xusf Exp */
/***********************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of
* California, as Operator of Los Alamos National Laboratory, and
* Berliner Elektronenspeicherring-Gesellschaft m.b.H. (BESSY).
* asynDriver is distributed subject to a Software License Agreement
* found in file LICENSE that is included with this distribution.
***********************************************************************/
/*
 * Author: Shifu Xu
 * Date:   03NOV2005
 */


#ifndef SAMPLER_H
#define SAMPLER_H

typedef struct delayMeasure
{
    unsigned long interruptLatency;
    unsigned long topToBottom;
    unsigned long bottomToUserInterrupt;
    unsigned long contextSwitch;
    unsigned long totalResponse;
} delayMeasure;

typedef int (*getSampleType) (void *samplerPvt, delayMeasure * pdelayMeasure);

typedef struct samplerManager
{
    int (*registerSampler) (const char *name, getSampleType getSample,
			    void *samplerPvt);
    int (*removeSampler) (void *samplerPvt);
} samplerManager;
extern samplerManager *psamplerManager;	/* epicsShareExtern */

#endif
